Sorry, your browser cannot access this site
This page requires browser support (enable) JavaScript
Learn more >

梦开始的地方-两数之和 力扣题号1

题目描述:
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1]。

示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:

输入:nums = [3,3], target = 6
输出:[0,1]
提示:

2 <= nums.length <= 104
-109 <= nums[i] <= 109
-109 <= target <= 109
只会存在一个有效答案

看到这个题目首先想到的就是双重for循环查找元素,但是这样的复杂度O(n2)

双重for循环
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
class Solution {
public int[] twoSum(int[] nums, int target) {

if (nums == null || nums.length == 0){
return null;
}

for (int i = 0; i < nums.length - 1; i++) {
for (int j = i + 1; j < nums.length; j++) {
if (nums[i] + nums[j] == target){
return new int[]{i,j};
}
}
}
return null;

}
}
哈希解法

除了暴力循环 还有哈希解法,比如可以利用map,这样的话只需要一层循环即可

查看代码
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] result = new int[2];
if (nums == null || nums.length == 0){
return result;
}
Map<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < nums.length; i++) {
int del = target - nums[i];
if (map.containsKey(del)){
result[0] = map.get(del);
result[1] = i;
return result;
}
map.put(nums[i],i);
}
return null;
}
}

评论